extends Benchmark

const BONES: Array[Dictionary] = [
	{ &"name": "spine", &"parent": -1 },
	{ &"name": "spine.001", &"parent": 0 },
	{ &"name": "spine.002", &"parent": 1 },
	{ &"name": "spine.003", &"parent": 2 },
	{ &"name": "spine.004", &"parent": 3 },
	{ &"name": "spine.005", &"parent": 4 },
	{ &"name": "spine.006", &"parent": 5 },
	{ &"name": "face", &"parent": 6 },
	{ &"name": "nose", &"parent": 7 },
	{ &"name": "nose.001", &"parent": 8 },
	{ &"name": "nose.002", &"parent": 9 },
	{ &"name": "nose.003", &"parent": 10 },
	{ &"name": "nose.004", &"parent": 11 },
	{ &"name": "lip.T.L", &"parent": 7 },
	{ &"name": "lip.T.L.001", &"parent": 13 },
	{ &"name": "lip.B.L", &"parent": 7 },
	{ &"name": "lip.B.L.001", &"parent": 15 },
	{ &"name": "jaw", &"parent": 7 },
	{ &"name": "chin", &"parent": 17 },
	{ &"name": "chin.001", &"parent": 18 },
	{ &"name": "ear.L", &"parent": 7 },
	{ &"name": "ear.L.001", &"parent": 20 },
	{ &"name": "ear.L.002", &"parent": 21 },
	{ &"name": "ear.L.003", &"parent": 22 },
	{ &"name": "ear.L.004", &"parent": 23 },
	{ &"name": "ear.R", &"parent": 7 },
	{ &"name": "ear.R.001", &"parent": 25 },
	{ &"name": "ear.R.002", &"parent": 26 },
	{ &"name": "ear.R.003", &"parent": 27 },
	{ &"name": "ear.R.004", &"parent": 28 },
	{ &"name": "lip.T.R", &"parent": 7 },
	{ &"name": "lip.T.R.001", &"parent": 30 },
	{ &"name": "lip.B.R", &"parent": 7 },
	{ &"name": "lip.B.R.001", &"parent": 32 },
	{ &"name": "brow.B.L", &"parent": 7 },
	{ &"name": "brow.B.L.001", &"parent": 34 },
	{ &"name": "brow.B.L.002", &"parent": 35 },
	{ &"name": "brow.B.L.003", &"parent": 36 },
	{ &"name": "lid.T.L", &"parent": 7 },
	{ &"name": "lid.T.L.001", &"parent": 38 },
	{ &"name": "lid.T.L.002", &"parent": 39 },
	{ &"name": "lid.T.L.003", &"parent": 40 },
	{ &"name": "lid.B.L", &"parent": 41 },
	{ &"name": "lid.B.L.001", &"parent": 42 },
	{ &"name": "lid.B.L.002", &"parent": 43 },
	{ &"name": "lid.B.L.003", &"parent": 44 },
	{ &"name": "brow.B.R", &"parent": 7 },
	{ &"name": "brow.B.R.001", &"parent": 46 },
	{ &"name": "brow.B.R.002", &"parent": 47 },
	{ &"name": "brow.B.R.003", &"parent": 48 },
	{ &"name": "lid.T.R", &"parent": 7 },
	{ &"name": "lid.T.R.001", &"parent": 50 },
	{ &"name": "lid.T.R.002", &"parent": 51 },
	{ &"name": "lid.T.R.003", &"parent": 52 },
	{ &"name": "lid.B.R", &"parent": 53 },
	{ &"name": "lid.B.R.001", &"parent": 54 },
	{ &"name": "lid.B.R.002", &"parent": 55 },
	{ &"name": "lid.B.R.003", &"parent": 56 },
	{ &"name": "forehead.L", &"parent": 7 },
	{ &"name": "forehead.L.001", &"parent": 58 },
	{ &"name": "forehead.L.002", &"parent": 59 },
	{ &"name": "temple.L", &"parent": 60 },
	{ &"name": "jaw.L", &"parent": 61 },
	{ &"name": "jaw.L.001", &"parent": 62 },
	{ &"name": "chin.L", &"parent": 63 },
	{ &"name": "cheek.B.L", &"parent": 64 },
	{ &"name": "cheek.B.L.001", &"parent": 65 },
	{ &"name": "brow.T.L", &"parent": 66 },
	{ &"name": "brow.T.L.001", &"parent": 67 },
	{ &"name": "brow.T.L.002", &"parent": 68 },
	{ &"name": "brow.T.L.003", &"parent": 69 },
	{ &"name": "forehead.R", &"parent": 7 },
	{ &"name": "forehead.R.001", &"parent": 71 },
	{ &"name": "forehead.R.002", &"parent": 72 },
	{ &"name": "temple.R", &"parent": 73 },
	{ &"name": "jaw.R", &"parent": 74 },
	{ &"name": "jaw.R.001", &"parent": 75 },
	{ &"name": "chin.R", &"parent": 76 },
	{ &"name": "cheek.B.R", &"parent": 77 },
	{ &"name": "cheek.B.R.001", &"parent": 78 },
	{ &"name": "brow.T.R", &"parent": 79 },
	{ &"name": "brow.T.R.001", &"parent": 80 },
	{ &"name": "brow.T.R.002", &"parent": 81 },
	{ &"name": "brow.T.R.003", &"parent": 82 },
	{ &"name": "eye.L", &"parent": 7 },
	{ &"name": "eye.R", &"parent": 7 },
	{ &"name": "cheek.T.L", &"parent": 7 },
	{ &"name": "cheek.T.L.001", &"parent": 86 },
	{ &"name": "nose.L", &"parent": 87 },
	{ &"name": "nose.L.001", &"parent": 88 },
	{ &"name": "cheek.T.R", &"parent": 7 },
	{ &"name": "cheek.T.R.001", &"parent": 90 },
	{ &"name": "nose.R", &"parent": 91 },
	{ &"name": "nose.R.001", &"parent": 92 },
	{ &"name": "teeth.T", &"parent": 7 },
	{ &"name": "teeth.B", &"parent": 7 },
	{ &"name": "tongue", &"parent": 7 },
	{ &"name": "tongue.001", &"parent": 96 },
	{ &"name": "tongue.002", &"parent": 97 },
	{ &"name": "shoulder.L", &"parent": 3 },
	{ &"name": "upper_arm.L", &"parent": 99 },
	{ &"name": "forearm.L", &"parent": 100 },
	{ &"name": "hand.L", &"parent": 101 },
	{ &"name": "palm.01.L", &"parent": 102 },
	{ &"name": "f_index.01.L", &"parent": 103 },
	{ &"name": "f_index.02.L", &"parent": 104 },
	{ &"name": "f_index.03.L", &"parent": 105 },
	{ &"name": "thumb.01.L", &"parent": 103 },
	{ &"name": "thumb.02.L", &"parent": 107 },
	{ &"name": "thumb.03.L", &"parent": 108 },
	{ &"name": "palm.02.L", &"parent": 102 },
	{ &"name": "f_middle.01.L", &"parent": 110 },
	{ &"name": "f_middle.02.L", &"parent": 111 },
	{ &"name": "f_middle.03.L", &"parent": 112 },
	{ &"name": "palm.03.L", &"parent": 102 },
	{ &"name": "f_ring.01.L", &"parent": 114 },
	{ &"name": "f_ring.02.L", &"parent": 115 },
	{ &"name": "f_ring.03.L", &"parent": 116 },
	{ &"name": "palm.04.L", &"parent": 102 },
	{ &"name": "f_pinky.01.L", &"parent": 118 },
	{ &"name": "f_pinky.02.L", &"parent": 119 },
	{ &"name": "f_pinky.03.L", &"parent": 120 },
	{ &"name": "shoulder.R", &"parent": 3 },
	{ &"name": "upper_arm.R", &"parent": 122 },
	{ &"name": "forearm.R", &"parent": 123 },
	{ &"name": "hand.R", &"parent": 124 },
	{ &"name": "palm.01.R", &"parent": 125 },
	{ &"name": "f_index.01.R", &"parent": 126 },
	{ &"name": "f_index.02.R", &"parent": 127 },
	{ &"name": "f_index.03.R", &"parent": 128 },
	{ &"name": "thumb.01.R", &"parent": 126 },
	{ &"name": "thumb.02.R", &"parent": 130 },
	{ &"name": "thumb.03.R", &"parent": 131 },
	{ &"name": "palm.02.R", &"parent": 125 },
	{ &"name": "f_middle.01.R", &"parent": 133 },
	{ &"name": "f_middle.02.R", &"parent": 134 },
	{ &"name": "f_middle.03.R", &"parent": 135 },
	{ &"name": "palm.03.R", &"parent": 125 },
	{ &"name": "f_ring.01.R", &"parent": 137 },
	{ &"name": "f_ring.02.R", &"parent": 138 },
	{ &"name": "f_ring.03.R", &"parent": 139 },
	{ &"name": "palm.04.R", &"parent": 125 },
	{ &"name": "f_pinky.01.R", &"parent": 141 },
	{ &"name": "f_pinky.02.R", &"parent": 142 },
	{ &"name": "f_pinky.03.R", &"parent": 143 },
	{ &"name": "breast.L", &"parent": 3 },
	{ &"name": "breast.R", &"parent": 3 },
	{ &"name": "pelvis.L", &"parent": 0 },
	{ &"name": "pelvis.R", &"parent": 0 },
	{ &"name": "thigh.L", &"parent": 0 },
	{ &"name": "shin.L", &"parent": 149 },
	{ &"name": "foot.L", &"parent": 150 },
	{ &"name": "toe.L", &"parent": 151 },
	{ &"name": "heel.02.L", &"parent": 151 },
	{ &"name": "thigh.R", &"parent": 0 },
	{ &"name": "shin.R", &"parent": 154 },
	{ &"name": "foot.R", &"parent": 155 },
	{ &"name": "toe.R", &"parent": 156 },
	{ &"name": "heel.02.R", &"parent": 156 },
]


class TestSkeleton extends Skeleton3D:
	var _spine_bone := -1
	var _head_bone := -1
	var _eye_left_bone := -1
	var _eye_right_bone := -1
	var _arm_left_bone := -1
	var _arm_right_bone := -1
	var _hand_left_bone := -1
	var _hand_right_bone := -1


	func _ready():
		for i in len(BONES):
			var bone := BONES[i]
			add_bone(bone.name)

		for i in len(BONES):
			var bone := BONES[i]
			set_bone_parent(i, bone.parent)

		_spine_bone = find_bone("spine.001")
		_head_bone = find_bone("spine.006")
		_eye_left_bone = find_bone("eye.L")
		_eye_right_bone = find_bone("eye.R")
		_arm_left_bone = find_bone("upper_arm.L")
		_arm_right_bone = find_bone("upper_arm.R")
		_hand_left_bone = find_bone("hand.L")
		_hand_right_bone = find_bone("hand.R")


class TestSkeletonSetAndGetSomeGlobalPoses extends TestSkeleton:
	func _process(_delta: float) -> void:
		for n in 1000:
			set_bone_pose(_spine_bone, get_bone_pose(_spine_bone))
			var _head_pose := get_bone_global_pose(_head_bone)

			set_bone_pose(_head_bone, get_bone_pose(_head_bone))
			var _eye_left_pose := get_bone_global_pose(_eye_left_bone)
			var _eye_right_pose := get_bone_global_pose(_eye_right_bone)

			set_bone_pose(_arm_left_bone, get_bone_pose(_arm_left_bone))
			set_bone_pose(_arm_left_bone, get_bone_pose(_arm_left_bone))
			var _hand_left_pose := get_bone_global_pose(_hand_left_bone)
			var _hand_right_pose := get_bone_global_pose(_hand_right_bone)


class TestSkeletonGetGlobalPoses extends TestSkeleton:
	func _process(_delta: float) -> void:
		for n in 1000:
			for i in get_bone_count():
				var _pose := get_bone_global_pose(i)


class TestSkeletonSetAllPoses extends TestSkeleton:
	func _process(_delta: float) -> void:
		for n in 1000:
			for i in get_bone_count():
				set_bone_pose_position(i, get_bone_pose_position(i))
				set_bone_pose_rotation(i, get_bone_pose_rotation(i))
				set_bone_pose_scale(i, get_bone_pose_scale(i))


class TestSkeletonSetAllPosesReverse extends TestSkeleton:
	func _process(_delta: float) -> void:
		for n in 1000:
			var i = get_bone_count() - 1
			while i >= 0:
				set_bone_pose_position(i, get_bone_pose_position(i))
				set_bone_pose_rotation(i, get_bone_pose_rotation(i))
				set_bone_pose_scale(i, get_bone_pose_scale(i))
				i -= 1


class TestSkeletonSetAndGetGlobalPosesForward extends TestSkeleton:
	func _process(_delta: float) -> void:
		for n in 500:
			for i in get_bone_count():
				set_bone_pose(i, get_bone_pose(i))
				var _pose := get_bone_global_pose(i)


class TestSkeletonSetAndGetGlobalPosesReverse extends TestSkeleton:
	func _process(_delta: float) -> void:
		for n in 500:
			var i = get_bone_count() - 1
			while i >= 0:
				set_bone_pose(i, get_bone_pose(i))
				var _pose := get_bone_global_pose(i)
				i -= 1


func _init() -> void:
	test_idle = true


func benchmark_set_and_get_some_global_poses() -> Node:
	return TestSkeletonSetAndGetSomeGlobalPoses.new()


func benchmark_get_global_poses() -> Node:
	return TestSkeletonGetGlobalPoses.new()


func benchmark_set_all_poses() -> Node:
	return TestSkeletonSetAllPoses.new()


func benchmark_set_all_poses_reverse() -> Node:
	return TestSkeletonSetAllPosesReverse.new()


func benchmark_set_and_get_global_poses_forward() -> Node:
	return TestSkeletonSetAndGetGlobalPosesForward.new()


func benchmark_set_and_get_global_poses_reverse() -> Node:
	return TestSkeletonSetAndGetGlobalPosesReverse.new()
